#ifndef ELECTRON_PLUGINS_MEDIAENCRYPTDECRYPTPLUGIN_
#define ELECTRON_PLUGINS_MEDIAENCRYPTDECRYPTPLUGIN_

#include "IMediaEncryptDecryptPlugin.h"

#include <string>
#include <mutex>

class MediaEncryptDecryptPlugin : public IMediaEncryptDecryptPlugin {
 public:
  MediaEncryptDecryptPlugin();
  ~MediaEncryptDecryptPlugin() override;

  bool init() override;
  bool uninit() override;
  bool load(const char* path) override;
  bool unload() override;
  bool enable(bool enabled) override;
  bool setParameter(const char* param) override;
  TRTC_PLUGIN_TYPE getPluginType() override;

  void setMallocMemoryCallback(MallocMemory callback) override;
  bool didEncodeVideo(EncodedData& data) override;
  bool willDecodeVideo(EncodedData& data) override;
  bool didEncodeAudio(EncodedData& data) override;
  bool willDecodeAudio(EncodedData& data) override;

 private:
  bool XORData(EncodedData& data);

  MallocMemory malloc_memory_callback_ = nullptr;

  bool inited_ = false;
  bool loaded_ = false;
  bool enabled_ = false;
  std::string folder_path_;
  std::string params_;
  std::string encrypt_key_;
  std::mutex mutex_;
};

#endif  // ELECTRON_PLUGINS_MEDIAENCRYPTDECRYPTPLUGIN_
